package edu.stanford.db.rdf.util;

import org.w3c.rdf.model.*;
import org.w3c.rdf.util.*;
import java.util.*;

public class AggregationUtil {

  /*
  public static Model pullOutNode(RDFNode n, Model m, RDFNode[] aggProp, RDFNode[] inverseAggProp) throws ModelException {

    Model result = m.create();
    Set r = new HashSet();
    pullOutNode(n, m, aggProp, inverseAggProp, r);

    // copy set to model
    return RDFUtil.toModel(r, result);
  }
  */

  /*
  public static void pullOutNode(RDFNode n, Model m, Collection aggProp, Collection inverseAggProp, Collection result) throws ModelException {

    Set visitedNodes = new HashSet();
    pullOutNode(n, m, aggProp, inverseAggProp, result, visitedNodes, 0);
  }
  */

  public static void pullOutNode(RDFNode n, Model m, RDFNode[] aggProp, RDFNode[] inverseAggProp, Collection result, Set visitedNodes, Set ignorableEdges) throws ModelException {

    Set s1 = new HashSet();
    s1.addAll(Arrays.asList(aggProp));

    Set s2 = new HashSet();
    s2.addAll(Arrays.asList(inverseAggProp));

    pullOutNode(n, m, s1, s2, result, visitedNodes, ignorableEdges, 0);
  }

  
  static void pullOutNode(RDFNode n, Model m, Collection aggProp, Collection inverseAggProp, Collection result, Set visitedNodes, Set ignorableEdges, int depth) throws ModelException {
    
    if(n == null || visitedNodes.contains(n))
      return;

    visitedNodes.add(n);

    // aggProp
    if(n instanceof Resource) {
      for(Enumeration en = m.find((Resource)n, null, null).elements(); en.hasMoreElements(); ) {
	
	Statement st = (Statement)en.nextElement();
	Resource pred = st.predicate();
	
	if((depth == 0 || aggProp.contains(pred)) && !ignorableEdges.contains(st)) {
	  
	  result.add(st);
	  // check for reified statements
	  pullOutNode(st, m, aggProp, inverseAggProp, result, visitedNodes, ignorableEdges, 0);
	  // need to pull out/examine object
	  pullOutNode(st.object(), m, aggProp, inverseAggProp, result, visitedNodes, ignorableEdges, depth+1);
	}
      }
    }

    // inverseAggProp
    for(Enumeration en = m.find(null, null, n).elements(); en.hasMoreElements(); ) {

      Statement st = (Statement)en.nextElement();
      Resource pred = st.predicate();

      if((depth == 0 || inverseAggProp.contains(pred)) && !ignorableEdges.contains(st)) {

	result.add(st);
	// check for reified statements
	pullOutNode(st, m, aggProp, inverseAggProp, result, visitedNodes, ignorableEdges, 0);
	// need to pull out/examine subject
	pullOutNode(st.subject(), m, aggProp, inverseAggProp, result, visitedNodes, ignorableEdges, depth+1);
      }
    }
  }
}
