#include <stdlib.h>

#include <stdio.h>

#include <assert.h>

#include <string.h>

#include "hull.h"

#include "org_ecoinformatics_seek_gis_grass_HullJniGlue.h"

#include <jni.h>



extern int GISHull(char *pointDataFile,char *hullDataFile);



JNIEXPORT jint JNICALL Java_org_ecoinformatics_seek_gis_grass_HullJniGlue_GISHull

  (JNIEnv * env, jobject, jstring s1,jstring s2)

{

  printf("Calling GISHull in CPP Code.\n");

  jboolean iscopy;

  char * dfile = (char*) env->GetStringUTFChars(s1, &iscopy);

  char * hfile = (char*) env->GetStringUTFChars(s2, &iscopy);

  printf("calling GISHull now\n");

  jint numh=GISHull(dfile,hfile);

  printf("DONE Calling GISHull in CPP Code.\n");

  return(numh);

}



int GISHull(char *pointDataFile, char *hullDataFile)

{

    printf("Running GISHull C code.");

    FILE* fdata,*fhull;

    struct Point *points;  /* point loaded from site file */

    int *hull;   /* index of points located on the convex hull */

	int i;

	int numSitePoints=0;

	if((fdata=fopen(pointDataFile,"r"))==NULL)

	{

		printf("can not open file %s\n",pointDataFile);

		return(-2);

	}	

	float x,y;

	char buf[2000];

	while(!feof(fdata))

	{	

		fgets(buf,2000,fdata);

		if(strcmp(buf,"")!=0)

			numSitePoints++;

		else

			break;

	}

    if(numSitePoints < 3 )

	{

        printf("Convex hull calculation requires at least three points");

		return(-1);

	}

	

	points=(struct Point *)malloc(numSitePoints*sizeof(struct Point));

	rewind(fdata);

	for(i=0;i<numSitePoints;i++)

	{

		fscanf(fdata,"%f %f",&x,&y);

		points[i].x=x;

		points[i].y=y;

		//printf("%10.5f %10.5f\n",points[i].x,points[i].y);

	}

	fclose(fdata);



    /* compute convex hull */

    int numHullPoints = convexHull(points, numSitePoints, &hull);

	if((fhull=fopen(hullDataFile,"w"))==NULL)

	{

		printf("can not open file %s\n",hullDataFile);

		return(-3);

	}

	for(i=0;i<numHullPoints;i++)

	{

		int idx=hull[i];

		//printf("%10d %10.5f %10.5f\n",idx,points[idx].x,points[idx].y);

		fprintf(fhull,"%10.5f %10.5f\n",points[idx].x,points[idx].y);

	}

	fclose(fhull);

	free(hull);

	free(points);

    return numHullPoints;

}



