#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#include "raster.h"

extern struct Cell_head region;
extern CELL **cell;

/*begin adoption from GRASS */

int begin_rasterization (int nrows, int ncols)
{
	int size = nrows *ncols;
	int i;
	cell = (CELL **) calloc (nrows, sizeof (CELL *));
	if(cell==NULL)
		return(-1);
	cell[0] = (CELL *) calloc (size, sizeof(CELL));
	if(cell[0]==NULL) 
		return(-2);
	for (i = 1; i < nrows; i++)
			cell[i] = cell[i-1] + region.cols;
	return(0);
}

/*end adoption from GRASS */

int do_rasterization(int nrows,int ncols,double *x,double *y,int npnts)
{
	G_setup_plot (-0.5, nrows-0.5, -0.5, ncols-0.5);
	return(G_plot_polygon(x,y,npnts));
}

void end_rasterization()
{
	free(cell[0]);
	free(cell);
}

