/* JUnit tests for the Collection class.
 *
 * Copyright (c) 2005 Natural Diversity Discovery Project.
 * All rights reserved.
 * 
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL THE NATURAL DIVERSITY DISCOVERY PROJECT BE LIABLE 
 * TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR 
 * CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND 
 * ITS DOCUMENTATION, EVEN IF THE NATURAL DIVERSITY DISCOVERY PROJECT
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE NATURAL DIVERSITY DISCOVERY PROJECT SPECIFICALLY DISCLAIMS ANY 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE NATURAL 
 * DIVERSITY DISCOVERY PROJECT HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

   @ProposedRating Red (tmcphillips@naturaldiversity.org)
   @AcceptedRating Red (tmcphillips@naturaldiversity.org) 
 */
 
package org.nddp; 

import junit.framework.TestCase;

/** 
 @author Timothy M. McPhillips
 */

public class TestCollection extends TestCase {
    
    ///////////////////////////////////////////////////////////////////
	////                         public methods                    ////

    public void testOneArgumentConstructor_EmptyName() throws Exception {
        
        Collection collection = new Collection("");
		assertEquals(collection.name(), "");     
		testAccessors(collection);
    }

    public void testOneArgumentConstructor_NonNullName() throws Exception {
        
        Collection collection = new Collection("Collection name");
		assertEquals(collection.name(), "Collection name");     
		testAccessors(collection);
    }
    
    public void testOneArgumentConstructor_NullName() throws Exception {
        
        	Collection collection = new Collection(null);        
		assertEquals(collection.name(), "");     
		testAccessors(collection);
    }
    
    public void testToString_EmptyName() throws Exception {
        
        Collection collection = new Collection();
		assertEquals(collection.toString(), "Collection");
    }

    public void testToString_NonEmptyName() throws Exception {
        
        	Collection collection = new Collection("Collection name");
		assertEquals(collection.toString(), "Collection name=\"Collection name\"");
    }
    
    public void testZeroArgumentConstructor() throws Exception {
        
        Collection collection = new Collection();
		assertEquals(collection.name(), "");
		testAccessors(collection);
    }

    ///////////////////////////////////////////////////////////////////
	////                         private methods                   ////

    private void testAccessors(Collection collection) throws Exception {
        
        assertEquals(collection.type(), "Collection");
        assertEquals(collection.closingDelimiter().collection(), collection);
        assertEquals(collection.openingDelimiter().collection(), collection);
    }
}
